// ObjectList.h
// Created by Bill Hubauer on Sun, May 28, 1995 @ 4:07 PM.

#ifndef __ObjectList__
#define __ObjectList__

#ifndef __ObjectQueue__
#include "ObjectQueue.h"
#endif

#ifndef __HeapObjects__
#include "HeapObjects.h"
#endif



class CObjectList : public CObjectQueue
{
public:
	CObjectList();
	virtual ~CObjectList();
	
	
	OSErr		AppendObject(void* object);
	void		RemoveObject(MQueueElem* objectElem);
	



	static void	SetObjectHeap(CHeap* theHeap)		{_objectHeap = theHeap;}
	static CHeap*		_objectHeap;
	
};


class	CListElem:public MQueueElem
{
	public:
		CListElem(void* data);
		virtual ~CListElem();
		void*	GetData()			{return _data;}
		
		void operator delete(void *x)		{ CObjectList::_objectHeap->Free((Ptr)x);}
		void *operator new(UInt32 theSize)	{ return CObjectList::_objectHeap->Allocate(theSize);}

	private:
		void*		_data;
};



#endif
